require 'test/unit'
require 'pairwise-sum'

#
# Demonstrations of the pairwise sum algorithms in pairwise-sum.rb.
# These aren't full unit tests, only examples to demonstrate the
# algorithms on a representative case.
#
# If you'd like to factor the repeated set-up code from the three
# methods, look into the Test::Unit::TestCase::setup() method.
#

class AlgorithmTests < Test::Unit::TestCase

  def testNormalizingAlgorithm
    a = [26, 42, -17, 47, -26, 1006]
    s = 16
    assert_equal(2, normalize_algorithm(a, s))
  end

  def testRyanNoyceBernsAlgorithm
    a = [26, 42, -17, 47, -26, 1006]
    s = 16
    result = rnb_algorithm(a, s)
    assert_equal(s, result[0]+result[1])
  end

  def testHashingAlgorithm
    a = [26, 42, -17, 47, -26, 1006]
    s = 16
    result = hashing_algorithm(a, s)
    assert_equal(s, result[0]+result[1])
  end

end
