#
# Three algorithms for this problem, from Sessions 23-24:
# Given an array of n numbers and an integer s, determine
# whether the array contains two numbers whose sum is s.
#

def normalize_algorithm( arr, sum )
  arr.each_index { |i| arr[i] -= sum/2 }
  arr_sorted = arr.sort { |x,y| x.abs <=> y.abs }
  (0..arr_sorted.length-2).each do |i|
    return i if arr_sorted[i] == -arr_sorted[i+1]
  end
  false
end

def rnb_algorithm( arr, sum )
  arr_sorted = arr.sort
  i = 0
  j = arr_sorted.length-1
  while (i < j) do
    current = arr_sorted[i] + arr_sorted[j]
    if current > sum
      j -= 1 
    elsif current < sum
      i += 1
    else
      return [ arr_sorted[i], arr_sorted[j] ]
    end
  end
  false
end

def hashing_algorithm( arr, sum )
  aux = Hash.new(false)
  arr.each do |i|
   return [ i, sum-i ] if aux[i]
   aux[sum-i] = true
  end
  false
end
